# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
def S4U::get_file_setting(dir_s4u_name,s4u_name)
	begin
		file_name = s4u_name + ".dat"
		file_name_full = File.join dir_s4u_name,file_name
		if File.exist?(file_name_full)
			file= File.new(file_name_full,"r")
			str=file.readlines
			file.close
			return str.collect{|s| s.chomp}
		end
		return false
	rescue
		return false
	end
end
def S4U::set_file_setting(dir_s4u_name,s4u_name,list)
	begin
		file_name = s4u_name + ".dat"
		file_name_full = File.join dir_s4u_name,file_name
		file= File.new(file_name_full,"w")
		list.each{|s| file.write(s.to_s+"\n")}
		file.close
		return true
	rescue
		return false
	end
end
module S4U
	module S4u_multi_slice
		@setting=[]
		class Slice
			def initialize(slice_mode=0)
				@slice_mode=slice_mode
				@strings=S4U::S4u_multi_slice::Strings
				@slice_mode_list=[@strings.GetString("Slice"),@strings.GetString("Cut"),@strings.GetString("Detach")]
				@slice_inside_list=[@strings.GetString("No Inside"),@strings.GetString("Inside")]
				@plane_type_list=[@strings.GetString("Set plane by Points"),@strings.GetString("Set plane by Object")]
				@section_type_list=[@strings.GetString("No Section Faces"),@strings.GetString("Add Section Faces"),@strings.GetString("Add Section Faces(Group)")]
				@hidden_line_list = [@strings.GetString("Show Section Line"),@strings.GetString("Hidden Section Line")]
				@rever_plane=0# if !@rever_plane
				@scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1
				@snap=15*@scale_factor
			end
			def activate
				model=Sketchup.active_model
				@edit_transform=Sketchup.active_model.axes.transformation
				@ip=Sketchup::InputPoint.new
				@ips=[]
				self.get_setting
				@slice_inside=1 if @slice_mode==2
				self.group_section()
				self.reset
			end
			def group_section
				if @slice_mode==3
					sel=model.selection
					@sectionplanes=sel.select{|e| e.is_a?Sketchup::SectionPlane}
					activesectionplane=@sectionplanes.find{|sp| sp.active?}
					@sectionplanes=[activesectionplane] if activesectionplane
					elements=sel.select{|e| e && e.valid? && ((e.is_a?Sketchup::Edge)||(e.is_a?Sketchup::Face)||(e.is_a?Sketchup::Group)||(e.is_a?Sketchup::ComponentInstance))}
					if !@sectionplanes.empty? and !elements.empty?
						@sectionplanes.each{|sectionplane|
							plane = sectionplane.get_plane.to_a
							v=Geom::Vector3d.new(plane[0],plane[1],plane[2])
							line = [Geom::Point3d.new(0, 0, 0), v]
							p=Geom.intersect_line_plane(line, plane)
							pl=[p,v.reverse]
							process_slice([pl,nil,nil])
						}
						model.select_tool(nil)
					end
				end
			end
			def getExtents
				bb = Sketchup.active_model.bounds
				bb.add @ip.position if @ip.valid?
				@ips.each{|p| bb.add(p.position) if p && p.valid?}
				return bb
			end
			def get_setting
				@setting = S4U::S4u_multi_slice::instance_variable_get :@setting
				if @setting && @setting.length==5
					@slice_inside=@setting[0]
					@plane_type=@setting[1]
					@section_type=@setting[2]
					@hidden_line=@setting[3]
					@slice_mode=@setting[4] if @slice_mode==4
				else
					self.get_setting_from_file(S4U::S4u_multi_slice::NAME)
				end
			end
			def get_setting_from_file(file=nil)
				@slice_inside=1
				@plane_type=0
				@section_type=1
				@hidden_line=0
				begin
					if file &&  S4U::S4u_multi_slice::Dir_s4u_name && (s=S4U::get_file_setting(S4U::S4u_multi_slice::Dir_s4u_name,file)) && s.length==5
						i=-1
						@slice_inside=s[i+=1].to_i
						@plane_type=s[i+=1].to_i
						@section_type=s[i+=1].to_i
						@hidden_line=s[i+=1].to_i
						@slice_mode=s[i+=1].to_i if @slice_mode==4
					else
						@slice_mode=0
						puts "No get setting"
					end
				rescue
					@slice_mode=0
					puts "error get setting"
				end
			end
			def deactivate(view)
				@setting=[]
				@setting[0]=@slice_inside
				@setting[1]=@plane_type
				@setting[2]=@section_type
				@setting[3]=@hidden_line
				@setting[4]=@slice_mode
				S4U::S4u_multi_slice::instance_variable_set(:@setting,@setting)
				(puts "error save setting") if not(S4U::S4u_multi_slice::Dir_s4u_name && S4U::set_file_setting(S4U::S4u_multi_slice::Dir_s4u_name,S4U::S4u_multi_slice::NAME,@setting))
			end
			def setstatus(view=nil)
				text = @strings.GetString("Slice Mode") + ": "
				text+= @slice_mode_list[@slice_mode].upcase + " | "
				text+=@strings.GetString("Slice	 Inside") + ": "

				text+=@slice_inside_list[@slice_inside].upcase
				text+= " (" + @strings.GetString("Press Down for change") +") "
				# text+= " | " + @section_type_list[@section_type]
				text+= " | " + @plane_type_list[@plane_type]
				(text+="(" + @strings.GetString("Ctrl -> Lock Zaxis") + ")" ) if @plane_type==0
				text+=" | "
				(text+=  @strings.GetString("Side Cut(Press TAB)") + " | ") if @slice_mode==1
				if @alt_press
					text+= @strings.GetString("Select Object")
				elsif @state==0 && @plane_type!=2
					text+=@strings.GetString("Select First Point")
				elsif @state>=1 #&& @plane_type==1
					text+= @strings.GetString("Double Click or First Point for Finish")
				elsif @plane_type==2
					text+= @strings.GetString("Select Object")
				end
				Sketchup.status_text=text
				view.invalidate if view
			end
			def draw(view)
					view.line_width=2
					#view.drawing_color= "red"
					if @ip && @ip.valid?
						if @onpoint
							view.draw_points @ip.position, 10*@scale_factor, 1, "red"
						elsif @edge
							view.draw_points @ip.position, 10*@scale_factor, 1, "red"
						elsif @ip.display?
							@ip.draw(view)
						end
					end
					if @alt_press
						if (@plane_type==2 || @alt_press) && @ip
							view.drawing_color ="blue"
							view.line_width=4
							if @ip && @trans
								p=@ip.position
								length = view.pixels_to_model (20), p
								vx=@plane_transform.xaxis;vy=@plane_transform.yaxis
								vx.length=vy.length=length
								p1=p+(vx+vy)
								p2=p+(vx.reverse+vy)
								p3=p+(vx.reverse+vy.reverse)
								p4=p+(vx+vy.reverse)
								view.line_width=1
								view.draw_polyline [p1,p2,p3,p4,p1]
								view.draw GL_QUADS,[p1,p2,p3,p4]
								if @slice_mode==1
									v=@plane_transform.zaxis
									v.length=(view.pixels_to_model (20), p)
									v.reverse! if @rever_plane==0
									view.line_width=7
									view.drawing_color="orange"
									view.draw_polyline (p1+v),(p2+v),(p3+v),(p4+v),(p1+v)
								end
							end
						end
					elsif @state>=1 && @ips.length>0
						if @ip.valid?
							if @p_shift && @shift_press
								view.line_stipple = "."
								view.drawing_color ="blue"
								view.draw_line(@ip.position, @ips[@state-1].position)
								view.line_stipple = ""
								p2_line=@ip.position.project_to_line([@ips[@state-1].position,@p_shift])
								view.draw_points p2_line, 7, 2, "red"  if p2_line
								view.drawing_color = @plane_type==0 ? "red" : "blue"
								view.draw2d GL_LINES,[view.screen_coords(@ips[@state-1].position),view.screen_coords(p2_line)]
								view.drawing_color="red"
								view.line_width=3
								(0..@ips.length-2).each{|i|
									view.draw2d GL_LINES,[view.screen_coords(@ips[i].position),view.screen_coords(@ips[i+1].position)]
								}
							else
								view.drawing_color="red"
								view.line_width=3
								view.draw2d GL_LINES,[view.screen_coords(@ip.position),view.screen_coords(@ips[-1].position)]
								(0..@ips.length-2).each{|i|
									view.draw2d GL_LINES,[view.screen_coords(@ips[i].position),view.screen_coords(@ips[i+1].position)]
								}
							end
							if @slice_mode==1
								(0..@ips.length-2).each{|i|
									p1=view.screen_coords(@ips[i].position)
									p2=view.screen_coords(@ips[i+1].position)
									p2_p1=p2-p1
									p2_p1[2]=0
									v=Z_AXIS.cross p2_p1
									if v and v.length>0
										v.reverse! if @rever_plane==1
										v.length=15
										p11=p1.clone + v
										p21=p2.clone + v
										view.line_width=7
										view.drawing_color="orange"
										view.draw2d GL_LINES,p11,p21
									end
								}
									p1=view.screen_coords(@ips[@state-1].position)
									p2=view.screen_coords( @p_shift ? @ip.position.project_to_line([@ips[@state-1].position,@p_shift]) : @ip.position)
									p2_p1=p2-p1
									p2_p1[2]=0
									v=Z_AXIS.cross p2_p1
									if v and v.length>0
										v.reverse! if @rever_plane==1
										v.length=15
										p11=p1.clone + v
										p21=p2.clone + v
										view.line_width=7
										view.drawing_color="orange"
										view.draw2d GL_LINES,p11,p21
									end
							end
						end

					end
				self.setstatus
			end
			def set_pointonedge(x,y,view,ip,edge)
				p1=edge.start.position.clone
				p2=edge.end.position.clone
				return nil if edge.length < (view.pixels_to_model(100*@scale_factor, p1))
				points= [Geom.linear_combination(2.0/3, p1,1.0/3, p2),Geom.linear_combination(1.0/3, p1,2.0/3, p2)]
				ph = view.pick_helper
				ph.init(x, y)
				picked = points.find{|p| ph.test_point((p.transform ip.transformation),x,y,@snap) }
				if picked
					ip1=Sketchup::InputPoint.new(picked.transform ip.transformation)
					p=view.screen_coords(picked.transform ip.transformation)
					ip.pick view,p.x,p.y,ip1
					view.tooltip=@strings.GetString("1/3")
				end
				return nil
			end
			def set_onpoint(x,y,view,ip,point)
				return nil if !ip || !point
				ph = view.pick_helper
				ph.init(x, y)
				picked = ph.test_point((point.position),x,y,@snap)
				if picked
					ip1=Sketchup::InputPoint.new(point.position)
					p=view.screen_coords(point.position)
					ip.pick view,p.x,p.y,ip1
					view.tooltip=@strings.GetString("Close")
					return true
				end
				return nil
			end
			def onMoveConstructionLine(view,element)
				return nil if !element.is_a?(Sketchup::ConstructionLine)
				p=ORIGIN
				p1=p+element.direction
				line=p1-p
				line.reverse! if view.screen_coords(p1).x< view.screen_coords(p).x
				if @edit_transform.zaxis.parallel? line
					normal=@edit_transform.zaxis
				else
					normal=line.cross @edit_transform.zaxis
				end
				return normal
			end
			def onMouseMove(flags, x, y, view)

				@shift_press= (CONSTRAIN_MODIFIER_MASK&flags==CONSTRAIN_MODIFIER_MASK)
				@ctrl_press= (COPY_MODIFIER_MASK&flags==COPY_MODIFIER_MASK)
				@alt_press= (ALT_MODIFIER_MASK&flags==ALT_MODIFIER_MASK)
				@edge=nil;@trans=nil
				ph = view.pick_helper
				ph.do_pick(x, y)
				if @state==0
					@ip.pick view,x,y
					view.tooltip = @ip.tooltip
					@edge=set_pointonedge(x,y,view,@ip,@ip.edge) if @ip.valid? && @ip.edge
					#@rever_plane=0 if !@rever_plane
					@face=@ip.face
					@trans=@ip.transformation
					element=ph.best_picked
					@elements=[element] if element
					ip1 = view.inputpoint(x, y,Sketchup::InputPoint.new(@edit_transform.origin))
					p=ip1.position.transform @edit_transform.inverse
					if !@shift_press || !@plane_transform
						@plane_transform=@edit_transform
						if @ip.edge
							line=(@ip.edge.end.position.transform(@trans)-@ip.edge.start.position.transform(@trans))
							line.reverse! if view.screen_coords(@ip.edge.start.position.transform(@trans)).x> view.screen_coords(@ip.edge.end.position.transform(@trans)).x
							if @edit_transform.zaxis.parallel? line
								normal=@edit_transform.zaxis
							else
								normal=line.cross @edit_transform.zaxis
							end
							@plane_transform=Geom::Transformation.new(@ip.position,normal)
						elsif normal=onMoveConstructionLine(view,element)
							@plane_transform=Geom::Transformation.new(@ip.position,normal)
							view.tooltip=@strings.GetString("ConstructionLine")
						elsif (p.y==0 && p.z==0) || (p.x==0 && p.z==0)
							vector =@edit_transform.origin.vector_to ip1.position
							vector.reverse! if view.screen_coords(ip1.position).x < view.screen_coords(@edit_transform.origin).x
							if vector.length>0
								vz=vector.cross @edit_transform.zaxis
								if vz.length>0
									@plane_transform=Geom::Transformation.new(ip1.position,vz)
									view.tooltip=@strings.GetString("Axis")
								end
							end
						elsif @ip.face
							normal=S4U::S4u_multi_slice.normal_face(@face,@trans)
							@plane_transform=Geom::Transformation.new(@ip.position,normal)
						elsif element.is_a?Sketchup::SectionPlane
							plane = element.get_plane.to_a
							normal=Geom::Vector3d.new(plane[0],plane[1],plane[2])
							@plane_transform=Geom::Transformation.new(@ip.position,normal)
						end
					end
					view.invalidate if @ip.valid?
				elsif @state>=1
					best_pick = ph.all_picked
					@elements+= best_pick if best_pick
					@ip.pick view,x,y,@ips[@state-1]
					view.tooltip = @ip.tooltip
					@edge=set_pointonedge(x,y,view,@ip,@ip.edge) if @ip.valid? && @ip.edge
					@onpoint=set_onpoint(x,y,view,@ip,@ips[0]) if @ip.valid?
					view.invalidate if @ip.valid?
				end
			end
			def onLButtonDown(flags, x, y, view)
				model=view.model
				if @state==0
					if @ip.valid?
						if @plane_type==2 || @alt_press
							p1=@ip.position
							vz=@plane_transform.zaxis
							plane=[[p1,vz],nil,nil,[p1,vz.reverse]]
							@planes<<plane
							process_slice(plane)
							self.reset(view)
						else
							@ips<< Sketchup::InputPoint.new
							@ips[-1].copy! @ip
							add_ip(view.screen_coords(@ips[-1].position),view)
							@state+=1
							@elements.clear
						end
					end
				elsif (@state>=1) && @ip.valid?
					@ips<<Sketchup::InputPoint.new
					if @onpoint
						@ips[-1].copy! @ips[0]
						@ip.copy! @ips[0]
					else
						@ips[-1].copy! @ip
					end
					if @p_shift && @ip!=@ips[@state-1]
						p2_line=@ip.position.project_to_line([@ips[-2].position,@p_shift])
						@ips[-1].copy!(p2_line ? Sketchup::InputPoint.new(p2_line) : @ip)
					else
						@ips[-1].copy! @ip
					end
					add_ip(view.screen_coords(@ips[-1].position),view)
					if @ips.length>1 && (@plane_type==0 || @ctrl_press )
						plane=add_plane
						@planes<<plane if plane
					end
					view.lock_inference if view.inference_locked?
					if @onpoint
						process_slice(@planes)
						self.reset(view)
					else
						@state+=1
					end
				end
				self.setstatus(view)
				rescue=>error
					p error
					p error.backtrace.join('\n')
					self.reset(view)
			end
			def add_ip(p_screen,view=Sketchup.active_model.active_view)
				ray=view.pickray p_screen.x, p_screen.y
				@ips[-1].pick(view,p_screen.x, p_screen.y)
				@rays[@ips[-1]]=ray
			end
			def add_plane(ip1=@ips[-2],ip2=@ips[-1])
				p1=ip1.position
				p2=ip2.position
				vx= p1.vector_to p2
				vz=Z_AXIS
				vy=vz.cross vx
				plane=nil
				if  @ctrl_press && vy.length>0
					if vy.length>0
						plane=[[p1,vy],[p1,vx],[p2,vx.reverse],[p1,vy.reverse]]
						return plane
						#@planes<<plane
					end
				else
					ray1=@rays[ip1]
					ray=@rays[ip2]
					if ray && ray1
						vec= p1.vector_to p2
						normal=vec.cross ray[1]
						normal1=ray[1].cross vec
						if normal.length>0 && normal1.length>0
							v1=ray1[1].cross normal
							v=normal.cross ray[1]
							if v.length>0 and v1.length>0
								plane=[[p1,normal],[p1,v1],[p2,v],[p1,normal1]]
								return plane
								#@planes<<plane
							end
						end
					end
				end
				return plane
			end
			def onLButtonDoubleClick(flags, x, y, view)
				if (@state>=1) && @ip.valid?
					process_slice(@planes)
					self.reset(view)
				end
			end
			def check_direction_points(ps_screen,rever_plane=0)
				i= (ps_screen.length>2)? 1 : 0
				p = S4U::S4u_multi_slice.middle_point([ps_screen[i],ps_screen[i+1]])
				v=ps_screen[i+1]-ps_screen[i]
				v1=v.cross Z_AXIS
				v1.length=5
				v1.reverse! if rever_plane==1
				p =p + v1
				return Geom.point_in_polygon_2D( p,ps_screen,false)
			end
			def process_slice(plane)
				model=Sketchup.active_model
				entities=model.active_entities
				view=Sketchup.active_model.active_view
				model.start_operation @strings.GetString("Slice Tools"),true,false,false
					sel=model.selection.to_a
					ent=[];get_select=true;g=g1=nil
					if sel.empty?
						@elements.flatten!
						@elements.uniq!
						sel=(@elements & model.active_entities.to_a)
						get_select=false
					end
					if sel.length>0
						no_sel=entities.to_a-sel
						start=true
						planes_ins=[]

						if @slice_mode==1
							(0..@planes.length-1).each{|i|
								if @rever_plane==1
									t=@planes[i][0][1]
									@planes[i][0][1]=@planes[i][3][1]
									@planes[i][3][1]=t.clone
								end
							}
						end
						if @planes.length>1
							ps_screen,planes= get_polygon(sel,view)
							if @slice_mode==1
								(0..planes.length-1).each{|i|
									if @rever_plane==1
										t=planes[i][0][1]
										planes[i][0][1]=planes[i][3][1]
										planes[i][3][1]=t
									end
								}
							end
							in_ps_screen=check_direction_points(ps_screen,@rever_plane)
							in_ps_screen= !in_ps_screen if @ctrl_press
							#close= (@onpoint ||view.screen_coords(@planes[0][0][0]).distance( view.screen_coords(@planes[-1][2][0]))<0.00001 )
							close=true
							planes_ins=[@planes,ps_screen,close,in_ps_screen,@ctrl_press,planes]
						else
							planes_ins=[@planes,[],false,true,@ctrl_press,@planes]
						end
						if (@slice_mode==0)
							S4U::S4u_multi_slice.cut_element(@slice_mode,entities,sel,planes_ins,0,@slice_inside,@section_type,Geom::Transformation.new,start,false,(@hidden_line==1))
						elsif @slice_mode==1
							planes_ins[0]=planes_ins[5].clone
							S4U::S4u_multi_slice.cut_element(@slice_mode,entities,sel,planes_ins,2,@slice_inside,@section_type,Geom::Transformation.new,start,false,(@hidden_line==1))
						elsif @slice_mode==2
							planes_ins[0]=planes_ins[5].clone
							S4U::S4u_multi_slice.cut_element(@slice_mode,entities,sel,planes_ins,2,@slice_inside,@section_type,Geom::Transformation.new,start,false,(@hidden_line==1))
						end
						if get_select
							sel=entities.to_a-no_sel
							ent1=sel.select{|e| e && e.valid? && ((e.is_a?Sketchup::Edge)||(e.is_a?Sketchup::Face)||(e.is_a?Sketchup::Group)||(e.is_a?Sketchup::ComponentInstance))}
							model.selection.add ent1 if ent1.length>0
						end

					end
					model.commit_operation
					# self.setstatus
				rescue=>error
					model.abort_operation
					p error
					p error.backtrace.join('\n')
			end
			def screen_coords(point,ctrl_press=@ctrl_press,view=Sketchup.active_model.active_view)
				p=ctrl_press ? Geom::Point3d.new(point.x,point.y,0) : view.screen_coords(point)
				return p
			end
			def get_triangle(sels,ips=@ips,view=Sketchup.active_model.active_view)
				bound= Geom::BoundingBox.new
				sels.each{|e| bound.add(e.bounds) if defined?(e.bounds)}
				ips.each{|p| bound.add(p.position)}
				corner_screen=(0..7).collect{|i| screen_coords(bound.corner(i))}
				min_max_x=corner_screen.minmax_by{|c| c.x}
				min_max_y=corner_screen.minmax_by{|c| c.y}
				dx=min_max_x[1].x-min_max_x[0].x
				dy=min_max_y[1].y-min_max_y[0].y
				min=Geom::Point3d.new(min_max_x[0].x,min_max_y[0].x,0)
				number=10
				p1=min.clone
				p1.x=p1.x-number*dx ; p1.y=p1.y-number*dy
				p2=min.clone
				p2.x=p2.x+number*dx
				p3=min.clone
				p3.y=p3.y+number*dy

				return [p1,p2,p3]
			end
			def get_vector_screen(vector)
				view=Sketchup.active_model.active_view
				origin=screen_coords(ORIGIN)
				p_origin=ORIGIN+vector
				p=screen_coords(p_origin)
				origin.z=0;p.z=0
				return (p-origin)
			end
			def get_polygon(sels,view=Sketchup.active_model.active_view)
				ps= @ips.collect{|p| screen_coords(p.position)}
				ps_screen=ps.collect{|p| Geom::Point3d.new(p.x,p.y,0)}
				ps_end=[]
				if !@onpoint
					line_end=[ps_screen[-2],ps_screen[-1]]
					line_start=[ps_screen[1],ps_screen[0]]
					p=Geom::intersect_line_line(line_end,line_start)
					if p && (!((Geom.point_in_polygon_2D(line_end[0],[line_end[1],p],true)) ||
						(Geom.point_in_polygon_2D(line_start[0],[line_start[1],p],true))))
						if Geom.point_in_polygon_2D(p,line_end,true) || Geom.point_in_polygon_2D(line_end[1],[line_end[0],p],true)
							ps_screen[-1]=p
						end
						if Geom.point_in_polygon_2D(p,line_start,true) || Geom.point_in_polygon_2D(line_start[1],[line_start[0],p],true)
							ps_screen[0]=p
						end
						ps_end<<p
					else
						triangle=get_triangle(sels,@ips,view)
						ps=triangle*2
						plane_end=nil
						plane_start=nil
						(0..2).each{|i|
							line=[ps[i],ps[i+1]]
							p = Geom::intersect_line_line(line,line_end)
							if p && (Geom.point_in_polygon_2D(p,[line[0],line[1]],true)) &&
								S4U::S4u_multi_slice.point_on_plane(p,[line_end[1],(line_end[1]-line_end[0])])>=0
								if S4U::S4u_multi_slice.point_on_plane(line[0],[p,get_vector_screen(@planes[-1][0][1])])>=0
									plane_end=[p,i]
								else
									plane_end=[p,i+1]
								end
							end
							p1 = Geom::intersect_line_line(line,line_start)
							if p1 && (Geom.point_in_polygon_2D(p1,[line[0],line[1]],true)) &&
								S4U::S4u_multi_slice.point_on_plane(p1,[line_start[1],(line_start[1]-line_start[0])])>=0
								if S4U::S4u_multi_slice.point_on_plane(line[0],[p1,get_vector_screen(@planes[0][0][1])])>=0
									plane_start=[p1,i]
								else
									plane_start=[p1,i+1]
								end
							end
							if p && p1 &&
								S4U::S4u_multi_slice.point_on_plane(p,[line_end[1],(line_end[1]-line_end[0])])>=0 &&
								S4U::S4u_multi_slice.point_on_plane(p1,[line_start[1],(line_start[1]-line_start[0])])>=0 &&
								(Geom.point_in_polygon_2D(p,[line[0],line[1]],true)) &&
								(Geom.point_in_polygon_2D(p1,[line[0],line[1]],true))
								ps_end<<p
								ps_end<<p1
							end
						}
						if ps_end.empty? && plane_start && plane_end
							ps_end<<plane_end[0]
							ps_end<<ps[plane_end[1]]
							plane_start[1]=(plane_start[1])%3
							plane_end[1]=(plane_end[1])%3
							step=plane_end[1]-plane_start[1]
							(0..step.abs).step(1).each{|i|
								s=step+i
								ps_end<< ps[s] if !ps_end.include?(ps[s])
							}
							ps_end<< ps[plane_start[1]] if plane_start[1] && !ps_end.include?(ps[plane_start[1]])
							ps_end<< plane_start[0] if plane_start[0] && !ps_end.include?(plane_start[0])
						end

					end
				end
				planes=[]
				ps1=[]
				(ps_screen+ps_end).each{|pi| (ps1<< pi) if !ps1.include?(pi)}
				ps1<<ps1[0] if ps1[-1]!=ps1[0]
				pend=ps1.clone
				@ips.clear
				@rays.clear
				(0..ps1.length-2).each{|i|
					if @ctrl_press
						@ips<<Sketchup::InputPoint.new(ps1[i])
						@ips<<Sketchup::InputPoint.new(ps1[i+1])
					else
						@ips<<Sketchup::InputPoint.new
						add_ip([ps1[i].x, ps1[i].y],view)
						@ips<<Sketchup::InputPoint.new
						add_ip([ps1[i+1].x, ps1[i+1].y],view)
					end
					plane=add_plane
					if plane
						planes<<plane
					end
				}
				#pend=@ips.collect{|p| p.position}
				return [pend,planes]
			end
			def getMenu(menu)
				menus=[]
				@slice_mode_list.each_index{|i| menus<< menu.add_item(@slice_mode_list[i]) {@slice_mode=i }}
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@slice_mode]) { MF_CHECKED }
				menu.add_separator
				menus=[]
				@slice_inside_list.each_index{|i| menus<< menu.add_item(@slice_inside_list[i]) {@slice_inside=i }}
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@slice_inside]) { MF_CHECKED }
				menu.add_separator
				menus=[]
				@plane_type_list.each_index{|i| menus<< menu.add_item(@plane_type_list[i]) {@plane_type=i } }
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@plane_type]) { MF_CHECKED }
				if @slice_mode==1
					menus<< menu.add_item(@strings["Reverse Side Cut"]){
							@rever_plane=1-@rever_plane
					}
				end
				menu.add_separator
				menus=[]
				@section_type_list.each_index{|i| menus<< menu.add_item(@section_type_list[i]) {@section_type=i }}
				menus.each{|m| menu.set_validation_proc(m) { MF_UNCHECKED }}
				menu.set_validation_proc(menus[@section_type]) { MF_CHECKED }
				menu.add_separator
				menus=[]
				@hidden_line_list.each_index{|i| menus<< menu.add_item(@hidden_line_list[i]) {@hidden_line=i }}
				menus.each{|m| menu.set_validation_proc(m){ MF_UNCHECKED }}
				menu.set_validation_proc(menus[@hidden_line]){ MF_CHECKED }
			end
			def onKeyDown(key, repeat, flags, view)
				#p flags
				if @plane_type==2
					if (key==CONSTRAIN_MODIFIER_KEY)
						@shift_press=true
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=true
					end
				else
					if key==CONSTRAIN_MODIFIER_KEY
						@shift_press=true
						if( @state==0 && @ip.valid? )
							view.lock_inference @ip if !@alt_press
						elsif( @state==1 && @ip.valid?)
							@p_shift=@ip.position
							view.lock_inference @ip if !@alt_press
						elsif( @state==2 && @ip.valid?)
							@p_shift=@ip.position
							view.lock_inference @ip if !@alt_press
						end
						self.setstatus(view)
					elsif key==VK_UP
						view.lock_inference if view.inference_locked?
						if @ip.valid? && @state>0  && @ips[-1] && @ips[-1].position
							p= @ips[-1].position
							p1=p + @edit_transform.zaxis
							ip1 = Sketchup::InputPoint.new(p1)
							ip = Sketchup::InputPoint.new(p)
							view.lock_inference ip1,ip
						end
					elsif key==VK_LEFT
						view.lock_inference if view.inference_locked?
						if @ip.valid? && @state>0 && @ips[-1] && @ips[-1].position
							p=  @ips[-1].position
							p1=p + @edit_transform.yaxis
							ip1 = Sketchup::InputPoint.new(p1)
							ip = Sketchup::InputPoint.new(p)
							view.lock_inference ip1,ip
						end
					elsif key==VK_RIGHT
						view.lock_inference if view.inference_locked?
						if @ip.valid? && @state>0 && @ips[-1] && @ips[-1].position
							p= @ips[-1].position
							p1=p + @edit_transform.xaxis
							ip1 = Sketchup::InputPoint.new(p1)
							ip = Sketchup::InputPoint.new(p)
							view.lock_inference ip1,ip
						end
					elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
						@ctrl_press=true
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=true
					end
				end
			end
			def onKeyUp(key, repeat, flags, view)
				if @plane_type==2
					if (key==CONSTRAIN_MODIFIER_KEY)
						@shift_press=nil
					elsif (key==9) || ((key==48) && IS_OSX)
						(@rever_plane=1-@rever_plane)
						self.setstatus(view)
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=nil
					elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
						@ctrl_press=nil
					end
				else
					if (key==CONSTRAIN_MODIFIER_KEY)
						view.lock_inference if view.inference_locked?
						@p_shift=nil
						@shift_press=nil
					elsif (key==9) || ((key==48) && IS_OSX)
						@rever_plane=1-@rever_plane
						self.setstatus(view)
					elsif key==VK_DOWN
						@slice_inside=1-@slice_inside
						self.setstatus(view)
					elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
						@ctrl_press=nil
					elsif (key==VK_ALT && IS_WIN )|| ((key==VK_CONTROL) && IS_OSX)
						@alt_press=nil
					end
				end
			end
			def onCancel(reason, view)
				self.reset(view)
			end
			def onReturn(view)
				if (@state>=1) && @ip.valid? && @ips.length>1
					#@onpoint=true
					process_slice(@planes)
					self.reset(view)
				end
			end
			def reset(view=nil)
				view.lock_inference if view
				@rays={}
				@elements=[]
				@state=0
				@ips=[]
				@ip.clear
				@sectionplanes=[]
				@onpoint=false
				@planes=[]
				self.setstatus(view)
			end
			def resume(view)
				self.setstatus(view)
			end
		end
		def self.cut_element(cut_mode,entities,sel,planes_ins,cut_hide,cut_inside,section_type,t,start,group_section,hidden_line,parent=nil)
			if start
				no_sel=entities.to_a-sel
			end
			planes_in=planes_ins[0]
			planes=planes_in.transpose
			result=true
			gc=sel.select{|e|  e && e.valid? && (e.is_a?(Sketchup::ConstructionPoint) || e.is_a?(Sketchup::Group) || e.is_a?(Sketchup::ComponentInstance))}
			gc.each{|element|
				on_plane=element_on_planes(element,planes_ins,t)
				#p on_plane
				if on_plane==1
					element.erase! if element && element.valid? && (cut_hide==1 || cut_hide==2 ) && ((start && cut_mode!=2) || (!start))
				elsif on_plane==0 && (element.is_a?(Sketchup::Group) || element.is_a?(Sketchup::ComponentInstance))
					if cut_inside==1
						ent=en1=nil
						element.make_unique if cut_mode!=3
						element1=nil
						if element.is_a?Sketchup::Group
							element.definition.invalidate_bounds
							ent=element.entities
							if cut_mode==2 && start
								element1=element.copy
								element1.make_unique
								S4U::S4u_multi_slice.set_attribute_element(element1,S4U::S4u_multi_slice.get_attribute_element(element))
								ent1=element1.entities

							end
						elsif element.is_a?Sketchup::ComponentInstance
							ent=element.definition.entities
							if cut_mode==2 && start
								element1=entities.add_instance(element.definition,element.transformation)
								element1.make_unique
								S4U::S4u_multi_slice.set_attribute_element(element1,S4U::S4u_multi_slice.get_attribute_element(element))
								ent1=element1.definition.entities
							end
						end
						if ent
							cut_element(cut_mode,ent,ent,planes_ins,cut_hide,cut_inside,section_type,t*element.transformation,false,group_section,hidden_line,element)
							if ent1 && cut_inside==1 && start && cut_mode==2
								plan=planes_ins[0].collect{|p| [p[3],p[1],p[2],p[0]]}
								planes_ins_reverse= [plan,planes_ins[1],planes_ins[2],!planes_ins[3],planes_ins[4],planes_ins[5]]
								cut_element(cut_mode,ent1,ent1,planes_ins_reverse,cut_hide,cut_inside,section_type,t*element1.transformation,false,group_section,hidden_line,element)
							end
						end
					end
				end
			}
			faces=[];edges=[]
			planes_in.each_index{|index|
				pl=planes_in[index]
				#if pl
					plane=pl[0]
					plane11=plane1=pl[1]
					plane21=plane2=pl[2]
					if planes_in.length>1
						if planes_ins[2]
							if index==0
								plane11= planes_in[-1][0]
								plane21=planes_in[1][0]
							elsif index>0 && index<(planes_in.length-1)
								plane11= planes_in[index-1][0]
								plane21=planes_in[index+1][0]
							else
								plane11= planes_in[-2][0]
								plane21=planes_in[0][0]
							end
						else
							if index==0
								plane11=nil if cut_mode!=0
								plane21=planes_in[1][0]
							elsif index>0 && index<(planes_in.length-1)
								plane11=planes_in[index-1][0]
								plane21=planes_in[index+1][0]
							elsif index==(planes_in.length-1)
								plane11=planes_in[-2][0]
								plane21=nil if cut_mode!=0
							end
						end
					else
						plane11=nil
						plane21=nil
					end
					faces=sel.select{|e| e && (e.valid?) && (e.is_a?Sketchup::Face)}
					faces.each{|e|
						if e && e.valid?
							points=[]
							e.edges.each{|ed|
								ps=ed.start.position.transform t
								pe=ed.end.position.transform  t
								p=Geom.intersect_line_plane([ps,pe], plane)
								(points<< p) if p && (Geom.point_in_polygon_2D(p,[ps,pe],true))
							}
							points=points.sort{|a,b| [a.x,a.y,a.z] <=> [b.x,b.y,b.z] }
							(0..points.length-2).each{|i|
								if points[i]!= points[i+1]
									p11=points[i].clone.transform((t).inverse)
									p21=points[i+1].clone.transform((t).inverse)
									pl=e.classify_point(Geom::Point3d.linear_combination(0.5,p11,0.5,p21))
									if (pl==1) || (pl==2) || (pl==4)
										ps=points[i]
										pe=points[i+1]
										if plane11 && plane21
											ps_on_plane = (point_on_plane(ps,plane1)>=0)
											pe_on_plane = (point_on_plane(pe,plane1)>=0)
											p1=p2=nil
											if points_on_plane([ps,pe],plane1) || (ps_on_plane && pe_on_plane)
												p1=ps;p2=pe
											elsif  (ps_on_plane || pe_on_plane )
												point_plane=Geom.intersect_line_plane([ps,pe], plane11)
												if point_plane && (Geom.point_in_polygon_2D(point_plane,[ps,pe],true))
													if ps_on_plane
														p1=ps;p2=point_plane
													elsif pe_on_plane
														p1=point_plane;p2=pe
													end
												end
											end
											if p1 && p2
												ps=p1.clone
												pe=p2.clone
												p1=p2=nil
												ps_on_plane = (point_on_plane(ps,plane2)>=0)
												pe_on_plane = (point_on_plane(pe,plane2)>=0)
												if points_on_plane([ps,pe],plane2) || (ps_on_plane && pe_on_plane)
													p1=pe;p2=ps
												elsif  (ps_on_plane || pe_on_plane )
													point_plane=Geom.intersect_line_plane([ps,pe], plane21)
													if point_plane && (Geom.point_in_polygon_2D(point_plane,[ps,pe],true))
														if ps_on_plane
															p1=ps;p2=point_plane
														elsif pe_on_plane
															p1=point_plane;p2=pe
														end
													end
												end
												if p1 && p2
													p1=p1.transform((t).inverse)
													p2=p2.transform((t).inverse)
													edges << [p1,p2]
												end
											end
										elsif plane11 || plane21
											p1=p2=nil
											if plane11
												ps_on_plane = (point_on_plane(ps,plane1)>=0)
												pe_on_plane = (point_on_plane(pe,plane1)>=0)
												if points_on_plane([ps,pe],plane1) || (ps_on_plane && pe_on_plane)
													p1=ps;p2=pe
												elsif  (ps_on_plane || pe_on_plane )
													point_plane=Geom.intersect_line_plane([ps,pe], plane11)
													if point_plane && (Geom.point_in_polygon_2D(point_plane,[ps,pe],true))
														if ps_on_plane
															p1=ps;p2=point_plane
														elsif pe_on_plane
															p1=point_plane;p2=pe
														end
													end
												end
												if p1 && p2
													p1=p1.transform((t).inverse)
													p2=p2.transform((t).inverse)
													edges << [p1,p2]
												end
											else
												ps_on_plane = (point_on_plane(ps,plane2)>=0)
												pe_on_plane = (point_on_plane(pe,plane2)>=0)
												if points_on_plane([ps,pe],plane2) || (ps_on_plane && pe_on_plane)
													p1=ps;p2=pe
												elsif (ps_on_plane || pe_on_plane )
													point_plane=Geom.intersect_line_plane([ps,pe], plane21)
													if point_plane && (Geom.point_in_polygon_2D(point_plane,[ps,pe],true))
														if ps_on_plane
															p1=ps;p2=point_plane
														elsif pe_on_plane
															p1=point_plane;p2=pe
														end
													end
												end
												if p1 && p2
													p1=p1.transform((t).inverse)
													p2=p2.transform((t).inverse)
													edges << [p1,p2]
												end
											end
										else
											p1=ps.transform((t).inverse)
											p2=pe.transform((t).inverse)
											edges << [p1,p2]
										end
									end
								end
							}
						end
					}
						g=entities.add_group
						edges_new=[]
						edges.each{|e|
							edge=g.entities.add_edges(e[0],e[1])
							if (cut_hide==1) || (cut_hide==2)
								edge1= entities.add_edges(e[0],e[1])
								(edge1[0].hidden=hidden_line) if edge1 && edge1[0] && (edge1[0].is_a?Sketchup::Edge)
							end
							if edge && edge[0] && edge[0].valid? && (edge[0].is_a?Sketchup::Edge)
								edge[0].soft=true if cut_hide==1 || !cut_hide
								edge[0].hidden=hidden_line
								edges_new << edge[0]
							end
						}
						if (section_type!=0) #&& (planes_in.length==1)
							edges_new.uniq!
							faces=g.entities.grep(Sketchup::Face)
							edges_new.each{|e| e.find_faces}
							faces_new= g.entities.grep(Sketchup::Face) - faces
							fs=self.delete_hole(faces_new)
							fs.each{|f|
								if f && f.valid? && (f.is_a?Sketchup::Face)
									vec=self.normal_face(f,t)
									f.reverse!  if (!(vec.samedirection?(plane[1]))) || (vec.angle_between(plane[1])>=(Math::PI*0.5))
								end
							}
						end
						if section_type!=2
							g.explode if g && g.valid?
						elsif parent
							S4U::S4u_multi_slice.set_attribute_element(g,S4U::S4u_multi_slice.get_attribute_element(parent))
							S4U::S4u_multi_slice.copy_attribute_dictionaries(parent,g)
						end
				#end
			}
					ent_edges=sel.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}
					addedges=[]
					ent_edges.each{|ed|
						ps=ed.start.position.transform t
						pe=ed.end.position.transform  t
						planes_in.transpose[0].each{|plane|
							p=Geom.intersect_line_plane([ps,pe], plane)
							if p && (Geom.point_in_polygon_2D(p,[ps,pe],true))
								addedges<< [p.transform((t).inverse),ed]
							end
						}
					}
					addedges.each{|ep|  entities.add_line(ep[0],ep[1].start.position)}
					@count=0 if start || !@count
					Sketchup.status_text= Strings["Procesing level:"] +"#{@count}"
					@count+=1
					if ( (cut_hide==1) || (cut_hide==2) ) && ((start && cut_mode!=2) || (!start))
						# length_ent_edges=(sel.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge)}).length
						loop=0
						while(loop<2) do
							(sel=entities.to_a-no_sel) if start
							faces_delete=[]
							ver1=[]
							# length_ent_edges=(sel.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}).length
							sel.each{|e|
								if e && e.valid? && (e.is_a?Sketchup::Face)
									psv=e.vertices.collect{|pv| pv.position.transform t}
									center1=nil
									center=center_face(e)
									cp=e.classify_point(center_face(e))
									center1=center.transform(t) if cp && cp==Sketchup::Face::PointInside
									point_about=psv.all?{|p| points_on_planes([p,p],planes_ins)}
									if point_about
										faces_delete<<e
									elsif center1 && points_on_planes([center1,center1],planes_ins)
										faces_delete<<e
									end
								end
								if e && e.valid? && (e.is_a?Sketchup::Edge)
									ps=e.start.position.transform t
									pe=e.end.position.transform t
									if points_on_planes([ps,pe],planes_ins)
										ver1<< e
									end
								end
							}
							ver1.uniq!
							begin
							ver1.each{|e|(e.erase!) if e && (e.valid?) && (e.is_a?Sketchup::Edge)}
							faces_delete.each{|e|(e.erase!) if e && (e.valid?) && (e.is_a?Sketchup::Face)}
							rescue =>error
							p error
							p error.backtrace.join('\n')
							end
							loop+=1
						end
					end
		end
		def self.delete_hole(faces)
			faces1=faces.clone
			fd=[]
			i=0
			length=faces.length
			while (faces.length > 0) &&(i< length)
				f=faces.shift
				(f.loops - [f.outer_loop]).each{|l|
					fs=l.edges[0].faces
					l.edges.each{|e| fs= e.faces & fs }
					(fs-[f]).each{|fa|
						if fa.valid? && fa.loops.length>1
							faces = faces - [fa]
							fd<< fa
						end
					}
				}
				i+=1
			end
			fd.uniq!
			faces=faces1-fd
			fd1=[]
			i=0
			length=faces.length
			while (faces.length > 0) && (i< length)
				f=faces.shift
				(f.loops - [f.outer_loop]).each{|l|
					fs=l.edges[0].faces
					l.edges.each{|e| fs = e.faces & fs}
					(fs-[f]).each{|fa|
						 if  fa.valid?
							 faces = faces - [fa]
							 fd1<< fa
						 end
					 }
				}
				i+=1
			end
			fd1.uniq!
			faces1 -= (fd1 + fd)
			(fd1 + fd).each{|f| f.erase! if f && f.valid?}
			return faces1
			rescue => error
			p error
			p error.backtrace.join('\n')
			return nil
		end
		def self.screen_coords(point,ctrl_press,view=Sketchup.active_model.active_view)
			p=ctrl_press ? Geom::Point3d.new(point.x,point.y,0) : view.screen_coords(point)
			return p
		end
		def self.center_face(face)
			vertices= face.outer_loop.vertices
			numver=vertices.length
			cp=Geom::Point3d.new
			vertices.each{|v|
				cp.x=cp.x+v.position.x
				cp.y=cp.y+v.position.y
				cp.z=cp.z+v.position.z
			}
			cp.x=cp.x/ numver
			cp.y=cp.y/ numver
			cp.z=cp.z/ numver
			return cp
		end
		def self.points_on_plane(points,plane)
			p1=points[0].clone;p2=points[1].clone
			t_plane=Geom::Transformation.new(plane[0],plane[1])
			p1.transform! t_plane.inverse
			p2.transform! t_plane.inverse
			return (((p1.z>0) && (p2.z>=0)) || ((p1.z>=0) && (p2.z>0)))
		end
		def self.middle_point(points)
			return Geom::Point3d.linear_combination(0.5,points[0],0.5,points[1])
		end
		def self.intersect_line_planes_ins(line,planes_ins)
			intersect=[]
			planes_in=planes_ins[5]
			number=0.000001
			(0..(planes_in.length-1)).each{|i|
				plan= planes_in[i][0]
				plan1=planes_in[i][1]
				plan2=planes_in[i][2]
				p =Geom.intersect_line_plane(line,plan)
				if p && (point_on_plane(p,plan1)>=number) &&  (point_on_plane(p,plan2)>=number)
					intersect<<p
				end
			}
			intersect.uniq!
			intersect.sort!{|a,b| [a.x,a.y,a.z] <=> [b.x,b.y,b.z] }
			return intersect
		end
		def self.point_on_section_planes(point,planes_ins)
			#planes_ins=[@planes,ps_screen,close,in_ps_screen,@ctrl_press,@intersect_planes]
			planes_in=planes_ins[5]
			number=0.000001
			if planes_in.length==1
				return point_on_plane(point,planes_in[0][0])
			else
				points1=points2=points3=[]
				points1= intersect_line_planes_ins([point,X_AXIS],planes_ins)
				points2= intersect_line_planes_ins([point,Y_AXIS],planes_ins)
				points3= intersect_line_planes_ins([point,Geom::Vector3d.new(1,1,0)],planes_ins)
				[points1,points2,points3].each{|points|
				(0..points.length-2).each{|i|
					#if points[i]!= points[i+1]
						if i%2==0
							if Geom.point_in_polygon_2D(point,[points[i], points[i+1]],true)
								dis1=point.distance(points[i])
								dis2=point.distance(points[i+1])
								if dis1>number && dis2>number &&
									point!=points[i] && point!=points[i+1]
									return 1
								elsif dis1<=number || dis2<=number ||
									point==points[i] || point==points[i+1]
									return 0
								end
							end
						else
							if Geom.point_in_polygon_2D(point,[points[i], points[i+1]],true)
								dis1=point.distance(points[i])
								dis2=point.distance(points[i+1])
								if  dis1>number && dis2>number &&
									point!=points[i] && point!=points[i+1]
									return -1
								elsif dis1<=number || dis2<=number ||
									point==points[i] || point==points[i+1]
									return 0
								end
							end
						end
					#end
				}
				}
			end
			return -1
		end
		def self.points_on_planes(points,planes_ins)
			if planes_ins[0].length==1
				return points_on_plane(points,planes_ins[0][0][0])
			else
				mid=middle_point(points)
				pmid=point_on_section_planes(mid,planes_ins)
				if planes_ins[3]
					return (pmid>0)
				else
					return (pmid<0)
				end
			end
			return false
		end
		def self.point_about_planes_ins(points,planes_ins)
			#planes_ins=[@planes,ps_screen,close,in_ps_screen,@ctrl_press,@intersect_planes]
			if (planes_ins[0].length==1)
				if points.any?{|p| point_on_plane(p,planes_ins[0][0][0])>0}
					if points.any?{|p| point_on_plane(p,planes_ins[0][0][0])<0}
						return 0
					else
						return 1
					end
				elsif points.any?{|p| point_on_plane(p,planes_ins[0][0][0])==0}
					return 0
				else
					return -1
				end
			else
				view=Sketchup.active_model.active_view
				ps_screen=planes_ins[1]
				points_screen=points.collect{|p| [screen_coords(p,planes_ins[4]).x,screen_coords(p,planes_ins[4]).y,0]}
				if planes_ins[3]
					if points_screen.all?{|p| Geom.point_in_polygon_2D(p,ps_screen,false)}
						return 1
					elsif points_screen.any?{|p| Geom.point_in_polygon_2D(p,ps_screen,true)}
						return 0
					else
						return -1
					end
				else
					if points_screen.all?{|p| Geom.point_in_polygon_2D(p,ps_screen,false)}
						return -1
					elsif points_screen.any?{|p| Geom.point_in_polygon_2D(p,ps_screen,true)}
						return 0
					else
						return 1
					end
				end
			end
			return 0
		end
		def self.element_on_planes(element,planes_ins,t=Geom::Transformation.new)
			corner=[]
			combination=[]
			if element.is_a?(Sketchup::ConstructionPoint)
				corner<< element.position.transform(t)
			else
				bounds=element.bounds
				corner=(0..7).collect{|i| bounds.corner(i).transform(t)}
				combination=corner.combination(2)
				corner+=combination.collect{|ps| middle_point(ps)}
			end
			# p=point_about_planes_ins(corner,planes_ins)
			# if p!=0
				corner_screen=corner.collect{|p1| screen_coords(p1,planes_ins[4])}
				box=Geom::BoundingBox.new
				corner_screen.each{|p| box.add p}
				ps_screen=(0..3).collect{|i| box.corner(i)}
				if planes_ins[1].any?{|p1| Geom.point_in_polygon_2D(p1,ps_screen,true)}
					return 0
				else
					return point_about_planes_ins(corner,planes_ins)
				end
			# end
			return 0
		end
		def self.point_on_plane(point,plane)
			p1=point.clone
			t_plane=Geom::Transformation.new(plane[0],plane[1])
			p1.transform! t_plane.inverse
			return 0 if p1.z.abs<0.000001
			return p1.z
		end
		def self.normal_face(face,t=Sketchup.active_model.edit_transform)
			vx=nil;vy=nil;line=nil
			ver=face.outer_loop.vertices.collect{|v| v.position.transform t}
			(0..ver.length-2).each{|i|
				vx=ver[i].vector_to ver[i+1]
				line=ver[i],ver[i+1]
				if vx.length!=0 && line
					(0..ver.length-1).each{|i|
						v2=ver[i].project_to_line line
						vy=v2.vector_to ver[i]
						break if vy.length!=0
					}
					normal=vx.cross vy if vx && vy
					if normal.length!=0
						facenormal=face.normal.transform t
						normal.reverse! if (normal.angle_between facenormal) >= Math::PI*0.5
						return normal
					end
				end
			}
			return face.normal
		end
		def self.get_attribute_element(element)
			return {"layer"=>element.layer,"hidden"=>element.hidden?,"material"=>element.material,
					"casts_shadows"=>element.casts_shadows?,"receives_shadows"=>element.receives_shadows?}
		end
		def self.set_attribute_element(element,hash)
			hash.each{|k,v|
				if k=="layer"
					element.layer=v
				elsif k=="hidden"
					element.hidden=v
				elsif k=="material"
					element.material=v
				elsif k=="casts_shadows"
					element.casts_shadows=v
				elsif k=="receives_shadows"
					element.receives_shadows=v
				end
			}
			return element
		end
		def self.copy_attribute_dictionaries(parent,g)
			attrdicts = parent.attribute_dictionaries
			attrdicts.each{|attrdict|
				if attrdict.name
					g.attribute_dictionary(attrdict.name,true)
					attrdict.each_pair { | key, value |
						g.set_attribute attrdict.name,key,value
					}
				end
			} if attrdicts
			return true
			rescue =>error
			p error
			p error.backtrace.join('\n')
			return false
		end
		def self.main(slice_mode=0)
			Sketchup.active_model.select_tool Slice.new(slice_mode)
		end
	end
end